liblo: Low-level OSC API

liblo 0.36

Low-level OSC API

## Data Structures
struct | lo_server_config
| A configuration struct for initializing lo_server using lo_server_new_from_config(). More...

## Typedefs
typedef long double | lo_hires
| Type used to represent numerical values in conversions between OSC types.

## Enumerations
enum | lo_slip_encoding
| Used with lo_address_set_stream_slip() to specify whether sent messages should be encoded with SLIP, and whether the encoding should be single- or double-ENDed. More...

## Functions
int | lo_send_message (lo_address targ, const char *path, lo_message msg)
| Send a lo_message object to target targ.
int | lo_send_message_from (lo_address targ, lo_server serv, const char *path, lo_message msg)
| Send a lo_message object to target targ from address of serv.
int | lo_send_bundle (lo_address targ, lo_bundle b)
| Send a lo_bundle object to address targ.
int | lo_send_bundle_from (lo_address targ, lo_server serv, lo_bundle b)
| Send a lo_bundle object to address targ from address of serv.
lo_message | lo_message_new (void)
| Create a new lo_message object.
void | lo_message_incref (lo_message m)
| Add one to a message's reference count.
int | lo_message_decref (lo_message m)
| Subtract one from a message's reference count.
lo_message | lo_message_clone (lo_message m)
| Create a new lo_message object by cloning an already existing one.
void | lo_message_free (lo_message m)
| Free memory allocated by lo_message_new() and any subsequent lo_message_add_int32 lo_message_add*() calls.
void | lo_message_clear (lo_message m)
| Clear elements from a lo_message but do not free allocated memory.
int | lo_message_add (lo_message m, const char *types,...)
| Append a number of arguments to a message.
int | lo_message_add_varargs (lo_message m, const char *types, va_list ap)
| Append a varargs list to a message.
int | lo_message_add_int32 (lo_message m, int32_t a)
| Append a data item and typechar of the specified type to a message.
int | lo_message_add_float (lo_message m, float a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_string (lo_message m, const char *a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_blob (lo_message m, lo_blob a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_int64 (lo_message m, int64_t a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_timetag (lo_message m, lo_timetag a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_double (lo_message m, double a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_symbol (lo_message m, const char *a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_char (lo_message m, char a)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_midi (lo_message m, uint8_t a[4])
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_true (lo_message m)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_false (lo_message m)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_nil (lo_message m)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
int | lo_message_add_infinitum (lo_message m)
| Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.
lo_address | lo_message_get_source (lo_message m)
| Returns the source (lo_address) of an incoming message.
lo_timetag | lo_message_get_timestamp (lo_message m)
| Returns the timestamp (lo_timetag *) of a bundled incoming message.
char * | lo_message_get_types (lo_message m)
| Return the message type tag string.
int | lo_message_get_argc (lo_message m)
| Return the message argument count.
lo_arg ** | lo_message_get_argv (lo_message m)
| Return the message arguments. Do not free the returned data.
size_t | lo_message_length (lo_message m, const char *path)
| Return the length of a message in bytes.
void * | lo_message_serialise (lo_message m, const char *path, void *to, size_t *size)
| Serialise the lo_message object to an area of memory and return a pointer to the serialised form. Opposite of lo_message_deserialise().
lo_message | lo_message_deserialise (void *data, size_t size, int *result)
| Deserialise a raw OSC message and return a new lo_message object. Opposite of lo_message_serialise().
int | lo_server_dispatch_data (lo_server s, void *data, size_t size)
| Dispatch a raw block of memory containing an OSC message.
const char * | lo_address_get_hostname (lo_address a)
| Return the hostname of a lo_address object.
const char * | lo_address_get_port (lo_address a)
| Return the port/service name of a lo_address object.
int | lo_address_get_protocol (lo_address a)
| Return the protocol of a lo_address object.
char * | lo_address_get_url (lo_address a)
| Return a URL representing an OSC address.
void | lo_address_set_ttl (lo_address t, int ttl)
| Set the Time-to-Live value for a given target address.
int | lo_address_get_ttl (lo_address t)
| Get the Time-to-Live value for a given target address.
int | lo_address_set_iface (lo_address t, const char *iface, const char *ip)
| Set the network interface to use for a given target address.
const char * | lo_address_get_iface (lo_address t)
| Get the name of the network interface assigned to an OSC address.
int | lo_address_set_tcp_nodelay (lo_address t, int enable)
| Set the TCP_NODELAY flag on outgoing TCP connections.
int | lo_address_set_stream_slip (lo_address t, lo_slip_encoding encoding)
| Set outgoing stream connections (e.g., TCP) to be transmitted using the SLIP packetizing protocol.
lo_bundle | lo_bundle_new (lo_timetag tt)
| Create a new bundle object.
void | lo_bundle_incref (lo_bundle b)
| Add one to a bundle's reference count.
int | lo_bundle_add_message (lo_bundle b, const char *path, lo_message m)
| Adds an OSC message to an existing bundle.
int | lo_bundle_add_bundle (lo_bundle b, lo_bundle n)
| Adds an OSC bundle to an existing bundle.
size_t | lo_bundle_length (lo_bundle b)
| Return the length of a bundle in bytes.
unsigned int | lo_bundle_count (lo_bundle b)
| Return the number of top-level elements in a bundle.
lo_element_type | lo_bundle_get_type (lo_bundle b, int index)
| Gets the element type contained within a bundle.
lo_bundle | lo_bundle_get_bundle (lo_bundle b, int index)
| Gets a nested bundle contained within a bundle.
lo_message | lo_bundle_get_message (lo_bundle b, int index, const char **path)
| Gets a message contained within a bundle.
lo_timetag | lo_bundle_get_timestamp (lo_bundle b)
| Get the timestamp associated with a bundle.
void | lo_bundle_set_timestamp (lo_bundle b, lo_timetag t)
| Get the timestamp associated with a bundle.
void * | lo_bundle_serialise (lo_bundle b, void *to, size_t *size)
| Serialise the bundle object to an area of memory and return a pointer to the serialised form.
void | lo_bundle_clear (lo_bundle b)
| Clear elements from a lo_bundle but do not free allocated memory.
void | lo_bundle_free (lo_bundle b)
| Frees the memory taken by a bundle object.
void | lo_bundle_free_recursive (lo_bundle b)
| Frees the memory taken by a bundle object and its messages and nested bundles recursively.
void | lo_bundle_free_messages (lo_bundle b)
| Obsolete, use lo_bundle_free_recursive instead.
int | lo_is_numerical_type (lo_type a)
| Return true if the type specified has a numerical value, such as LO_INT32, LO_FLOAT etc.
int | lo_is_string_type (lo_type a)
| Return true if the type specified has a textual value, such as LO_STRING or LO_SYMBOL.
int | lo_coerce (lo_type type_to, lo_arg *to, lo_type type_from, lo_arg *from)
| Attempt to convert one OSC type to another.
lo_hires | lo_hires_val (lo_type type, lo_arg *p)
| Return the numerical value of the given argument with the maximum native system precision.
lo_server | lo_server_new (const char *port, lo_err_handler err_h)
| Create a new server instance.
lo_server | lo_server_new_with_proto (const char *port, int proto, lo_err_handler err_h)
| Create a new server instance, specifying protocol.
lo_server | lo_server_new_multicast (const char *group, const char *port, lo_err_handler err_h)
| Create a new server instance, and join a UDP multicast group.
lo_server | lo_server_new_multicast_iface (const char *group, const char *port, const char *iface, const char *ip, lo_err_handler err_h)
| Create a new server instance, and join a UDP multicast group, optionally specifying which network interface to use. Note that usually only one of iface or ip are specified.
lo_server | lo_server_new_from_url (const char *url, lo_err_handler err_h)
| Create a new server instance, taking port and the optional multicast group IP from an URL string.
lo_server | lo_server_new_from_config (lo_server_config *config)
| Create a new server instance, using a configuration struct.
int | lo_server_enable_coercion (lo_server server, int enable)
| Enables or disables type coercion during message dispatch.
void | lo_server_free (lo_server s)
| Free up memory used by the lo_server object.
int | lo_server_wait (lo_server s, int timeout)
| Wait for an OSC message to be received.
int | lo_servers_wait (lo_server *s, int *status, int num_servers, int timeout)
| Wait on multiple servers for an OSC message to be received.
int | lo_server_recv_noblock (lo_server s, int timeout)
| Look for an OSC message waiting to be received.
int | lo_servers_recv_noblock (lo_server *s, int *recvd, int num_servers, int timeout)
| Look for an OSC message waiting to be received on multiple servers.
int | lo_server_recv (lo_server s)
| Block, waiting for an OSC message to be received.
lo_method | lo_server_add_method (lo_server s, const char *path, const char *typespec, lo_method_handler h, const void *user_data)
| Add an OSC method to the specifed server.
void | lo_server_del_method (lo_server s, const char *path, const char *typespec)
| Delete an OSC method from the specified server.
int | lo_server_del_lo_method (lo_server s, lo_method m)
| Delete a specific OSC method from the specified server.
int | lo_server_add_bundle_handlers (lo_server s, lo_bundle_start_handler sh, lo_bundle_end_handler eh, void *user_data)
| Add bundle notification handlers to the specified server.
int | lo_server_get_socket_fd (lo_server s)
| Return the file descriptor of the server socket.
int | lo_server_get_port (lo_server s)
| Return the port number that the server has bound to.
int | lo_server_get_protocol (lo_server s)
| Return the protocol that the server is using.
char * | lo_server_get_url (lo_server s)
| Return an OSC URL that can be used to contact the server.
int | lo_server_enable_queue (lo_server s, int queue_enabled, int dispatch_remaining)
| Toggle event queue. If queueing is enabled, timetagged messages that are sent in advance of the current time will be put on an internal queue, and they will be dispatched at the indicated time. By default, queueing is enabled. Use this function to disable it, if it is desired to have a server process messages immediately. In that case, use lo_message_get_timestamp() to get the message timestamp from within a method handler.
int | lo_server_events_pending (lo_server s)
| Return true if there are scheduled events (eg. from bundles) waiting to be dispatched by the server.
double | lo_server_next_event_delay (lo_server s)
| Return the time in seconds until the next scheduled event.
int | lo_server_max_msg_size (lo_server s, int req_size)
| Set the maximum message size accepted by a server.
char * | lo_url_get_protocol (const char *url)
| Return the protocol portion of an OSC URL, eg. udp, tcp.
int | lo_url_get_protocol_id (const char *url)
| Return the protocol ID of an OSC URL.
char * | lo_url_get_hostname (const char *url)
| Return the hostname portion of an OSC URL.
char * | lo_url_get_port (const char *url)
| Return the port portion of an OSC URL.
char * | lo_url_get_path (const char *url)
| Return the path portion of an OSC URL.
int | lo_strsize (const char *s)
| A function to calculate the amount of OSC message space required by a C char *.
uint32_t | lo_blobsize (lo_blob b)
| A function to calculate the amount of OSC message space required by a lo_blob object.
int | lo_pattern_match (const char *str, const char *p)
| Test a string against an OSC pattern glob.
int | lo_string_contains_pattern (const char *str)
| Test if a string contains any OSC pattern characters.
double | lo_timetag_diff (lo_timetag a, lo_timetag b)
| Find the time difference between two timetags.
void | lo_timetag_now (lo_timetag *t)
| Return a timetag for the current time.
size_t | lo_arg_size (lo_type type, void *data)
| Return the storage size, in bytes, of the given argument.
char * | lo_get_path (void *data, ssize_t size)
| Given a raw OSC message, return the message path.
void | lo_arg_host_endian (lo_type type, void *data)
| Convert the specified argument to host byte order where necessary.
void | lo_arg_network_endian (lo_type type, void *data)
| Convert the specified argument to network byte order where necessary.

## Detailed Description

Use these functions if you require more precise control over OSC message contruction or handling that what is provided in the high-level functions described in liblo.

## Typedef Documentation

## ◆ lo_hires

typedef long double lo_hires

Type used to represent numerical values in conversions between OSC types.

Definition at line 56 of file lo_lowlevel.h.

## Enumeration Type Documentation

## ◆ lo_slip_encoding

enum lo_slip_encoding

Used with lo_address_set_stream_slip() to specify whether sent messages should be encoded with SLIP, and whether the encoding should be single- or double-ENDed.

Definition at line 85 of file lo_lowlevel.h.

## Function Documentation

## ◆ lo_address_get_hostname()

const char * lo_address_get_hostname | ( | lo_address | a | ) |

Return the hostname of a lo_address object.

Returned value must not be modified or free'd. Value will be a dotted quad, colon'd IPV6 address, or resolvable name.

## ◆ lo_address_get_iface()

const char * lo_address_get_iface | ( | lo_address | t | ) |

Get the name of the network interface assigned to an OSC address.

Parameters

  t | An OSC address.

Returns
  A string pointer or 0 if no interface has been assigned. Caller should not modify the provided string. It is a legal pointer until the next call to lo_address_set_iface or lo_address_free.

## ◆ lo_address_get_port()

const char * lo_address_get_port | ( | lo_address | a | ) |

Return the port/service name of a lo_address object.

Returned value must not be modified or free'd. Value will be a service name or ASCII representation of the port number.

## ◆ lo_address_get_protocol()

int lo_address_get_protocol | ( | lo_address | a | ) |

Return the protocol of a lo_address object.

Returned value will be one of LO_UDP, LO_TCP or LO_UNIX.

## ◆ lo_address_get_ttl()

int lo_address_get_ttl | ( | lo_address | t | ) |

Get the Time-to-Live value for a given target address.

Parameters

  t | An OSC address.

Returns
  An integer specifying the scope of a multicast UDP message.

## ◆ lo_address_get_url()

char * lo_address_get_url | ( | lo_address | a | ) |

Return a URL representing an OSC address.

Returned value must be free'd.

## ◆ lo_address_set_iface()

int lo_address_set_iface | ( | lo_address | t,
|  | const char * | iface,
|  | const char * | ip )

Set the network interface to use for a given target address.

The caller should specify either the iface or ip variable. The IP, if specified, should match the same network family as the OSC address. (That is, should correctly correspond to IPv4 or IPv6.) Typically the assigned network interface will only be used in the case of sending multicast messages. It is recommended to use the if_nameindex POSIX function to get a list of network interface names.

Parameters

  t | An OSC address.
  iface | The name of a network interface on the local system.
  ip | The IP address of a network interface on the local system.

Returns
  0 if the interface was successfully identified, or non-zero otherwise.

## ◆ lo_address_set_stream_slip()

int lo_address_set_stream_slip | ( | lo_address | t,
|  | lo_slip_encoding | encoding )

Set outgoing stream connections (e.g., TCP) to be transmitted using the SLIP packetizing protocol.

Parameters

  t | The address to set this flag for.
  encoding | Specify single- or double-ENDed SLIP, or disable SLIP.

Returns
  the previous value of this flag.

## ◆ lo_address_set_tcp_nodelay()

int lo_address_set_tcp_nodelay | ( | lo_address | t,
|  | int | enable )

Set the TCP_NODELAY flag on outgoing TCP connections.

Parameters

  t | The address to set this flag for.
  enable | Non-zero to set the flag, zero to unset it.

Returns
  the previous value of this flag.

## ◆ lo_address_set_ttl()

void lo_address_set_ttl | ( | lo_address | t,
|  | int | ttl )

Set the Time-to-Live value for a given target address.

This is required for sending multicast UDP messages. A value of 1 (the usual case) keeps the message within the subnet, while 255 means a global, unrestricted scope.

Parameters

  t | An OSC address.
  ttl | An integer specifying the scope of a multicast UDP message.

## ◆ lo_arg_host_endian()

void lo_arg_host_endian | ( | lo_type | type,
|  | void * | data )

Convert the specified argument to host byte order where necessary.

Parameters

  type | The OSC type of the data item (eg. LO_FLOAT).
  data | A pointer to the data item to be converted. It is changed in-place.

## ◆ lo_arg_network_endian()

void lo_arg_network_endian | ( | lo_type | type,
|  | void * | data )

Convert the specified argument to network byte order where necessary.

Parameters

  type | The OSC type of the data item (eg. LO_FLOAT).
  data | A pointer to the data item to be converted. It is changed in-place.

## ◆ lo_arg_size()

size_t lo_arg_size | ( | lo_type | type,
|  | void * | data )

Return the storage size, in bytes, of the given argument.

## ◆ lo_blobsize()

uint32_t lo_blobsize | ( | lo_blob | b | ) |

A function to calculate the amount of OSC message space required by a lo_blob object.

Returns the storage size in bytes, which will always be a multiple of four.

## ◆ lo_bundle_add_bundle()

int lo_bundle_add_bundle | ( | lo_bundle | b,
|  | lo_bundle | n )

Adds an OSC bundle to an existing bundle.

The child bundle passed is appended to the list of child bundles|messages in the parent bundle to be dispatched.

Returns
  0 if successful, less than 0 otherwise.

## ◆ lo_bundle_add_message()

int lo_bundle_add_message | ( | lo_bundle | b,
|  | const char * | path,
|  | lo_message | m )

Adds an OSC message to an existing bundle.

The message passed is appended to the list of messages in the bundle to be dispatched to 'path'.

Returns
  0 if successful, less than 0 otherwise.

## ◆ lo_bundle_clear()

void lo_bundle_clear | ( | lo_bundle | b | ) |

Clear elements from a lo_bundle but do not free allocated memory.

## ◆ lo_bundle_count()

unsigned int lo_bundle_count | ( | lo_bundle | b | ) |

Return the number of top-level elements in a bundle.

Parameters

  b | The bundle to be counted.

## ◆ lo_bundle_free()

void lo_bundle_free | ( | lo_bundle | b | ) |

Frees the memory taken by a bundle object.

Parameters

  b | The bundle to be freed.

## ◆ lo_bundle_free_messages()

void lo_bundle_free_messages | ( | lo_bundle | b | ) |

Obsolete, use lo_bundle_free_recursive instead.

Parameters

  b | The bundle, which may contain messages and nested bundles, to be freed.

## ◆ lo_bundle_free_recursive()

void lo_bundle_free_recursive | ( | lo_bundle | b | ) |

Frees the memory taken by a bundle object and its messages and nested bundles recursively.

Parameters

  b | The bundle, which may contain messages and nested bundles, to be freed.

## ◆ lo_bundle_get_bundle()

lo_bundle lo_bundle_get_bundle | ( | lo_bundle | b,
|  | int | index )

Gets a nested bundle contained within a bundle.

Returns a lo_bundle at a given index within a bundle.

Returns
  The requested lo_bundle if successful, otherwise 0.

## ◆ lo_bundle_get_message()

lo_message lo_bundle_get_message | ( | lo_bundle | b,
|  | int | index,
|  | const char ** | path )

Gets a message contained within a bundle.

Returns a lo_message at a given index within a bundle, and optionally the path associated with that message.

Returns
  The requested lo_message if successful, otherwise 0.

## ◆ lo_bundle_get_timestamp()

lo_timetag lo_bundle_get_timestamp | ( | lo_bundle | b | ) |

Get the timestamp associated with a bundle.

Parameters

  b | The bundle for which the timestamp should be returned.

Returns
  The timestamp of the bundle as a lo_timetag.

## ◆ lo_bundle_get_type()

lo_element_type lo_bundle_get_type | ( | lo_bundle | b,
|  | int | index )

Gets the element type contained within a bundle.

Returns a lo_element_type at a given index within a bundle.

Returns
  The requested lo_element_type if successful, otherwise 0.

## ◆ lo_bundle_incref()

void lo_bundle_incref | ( | lo_bundle | b | ) |

Add one to a bundle's reference count.

Bundles are reference counted. If a bundle is multiply referenced, the bundle's counter should be incremented. It is automatically decremented by lo_bundle_free lo_bundle_free_recursive, with lo_bundle_free_recursive being the preferable method.

## ◆ lo_bundle_length()

size_t lo_bundle_length | ( | lo_bundle | b | ) |

Return the length of a bundle in bytes.

Includes the marker and typetag length.

Parameters

  b | The bundle to be sized

## ◆ lo_bundle_new()

lo_bundle lo_bundle_new | ( | lo_timetag | tt | ) |

Create a new bundle object.

OSC Bundles encapsulate one or more OSC messages and may include a timestamp indicating when the bundle should be dispatched.

Parameters

  tt | The timestamp when the bundle should be handled by the receiver. Pass LO_TT_IMMEDIATE if you want the receiving server to dispatch the bundle as soon as it receives it.

## ◆ lo_bundle_serialise()

void * lo_bundle_serialise | ( | lo_bundle | b,
|  | void * | to,
|  | size_t * | size )

Serialise the bundle object to an area of memory and return a pointer to the serialised form.

Parameters

  b | The bundle to be serialised
  to | The address to serialise to, memory will be allocated if to is NULL.
  size | If this pointer is non-NULL the size of the memory area will be written here

The returned form is suitable to be sent over a low level OSC transport, having the correct endianess and bit-packed structure.

## ◆ lo_bundle_set_timestamp()

void lo_bundle_set_timestamp | ( | lo_bundle | b,
|  | lo_timetag | t )

Get the timestamp associated with a bundle.

Parameters

  b | The bundle for which the timestamp should be returned.
  t | The timestamp to write.

## ◆ lo_coerce()

int lo_coerce | ( | lo_type | type_to,
|  | lo_arg * | to,
|  | lo_type | type_from,
|  | lo_arg * | from )

Attempt to convert one OSC type to another.

Numerical types (eg LO_INT32, LO_FLOAT etc.) may be converted to other numerical types and string types (LO_STRING and LO_SYMBOL) may be converted to the other type. This is done automatically if a received message matches the path, but not the exact types, and is coercible (ie. all numerical types in numerical positions).

On failure no translation occurs and false is returned.

Parameters

  type_to | The type of the destination variable.
  to | A pointer to the destination variable.
  type_from | The type of the source variable.
  from | A pointer to the source variable.

## ◆ lo_get_path()

char * lo_get_path | ( | void * | data,
|  | ssize_t | size )

Given a raw OSC message, return the message path.

Parameters

  data | A pointer to the raw OSC message data.
  size | The size of data in bytes (total buffer bytes).

Returns the message path or NULL if an error occurs. Do not free() the returned pointer.

## ◆ lo_hires_val()

lo_hires lo_hires_val | ( | lo_type | type,
|  | lo_arg * | p )

Return the numerical value of the given argument with the maximum native system precision.

## ◆ lo_is_numerical_type()

int lo_is_numerical_type | ( | lo_type | a | ) |

Return true if the type specified has a numerical value, such as LO_INT32, LO_FLOAT etc.

Parameters

  a | The type to be tested.

## ◆ lo_is_string_type()

int lo_is_string_type | ( | lo_type | a | ) |

Return true if the type specified has a textual value, such as LO_STRING or LO_SYMBOL.

Parameters

  a | The type to be tested.

## ◆ lo_message_add()

int lo_message_add | ( | lo_message | m,
|  | const char * | types,
|  |  | ... )

Append a number of arguments to a message.

The data will be added in OSC byteorder (bigendian).

Parameters

  m | The message to be extended.
  types | The types of the data items in the message, types are defined in lo_types_common.h
  ... | The data values to be transmitted. The types of the arguments passed here must agree with the types specified in the type parameter.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_blob()

int lo_message_add_blob | ( | lo_message | m,
|  | lo_blob | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_char()

int lo_message_add_char | ( | lo_message | m,
|  | char | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_double()

int lo_message_add_double | ( | lo_message | m,
|  | double | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_false()

int lo_message_add_false | ( | lo_message | m | ) |

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_float()

int lo_message_add_float | ( | lo_message | m,
|  | float | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_infinitum()

int lo_message_add_infinitum | ( | lo_message | m | ) |

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_int32()

int lo_message_add_int32 | ( | lo_message | m,
|  | int32_t | a )

Append a data item and typechar of the specified type to a message.

The data will be added in OSC byteorder (bigendian).

Parameters

  m | The message to be extended.
  a | The data item.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_int64()

int lo_message_add_int64 | ( | lo_message | m,
|  | int64_t | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_midi()

int lo_message_add_midi | ( | lo_message | m,
|  | uint8_t | a[4] )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_nil()

int lo_message_add_nil | ( | lo_message | m | ) |

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_string()

int lo_message_add_string | ( | lo_message | m,
|  | const char * | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_symbol()

int lo_message_add_symbol | ( | lo_message | m,
|  | const char * | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_timetag()

int lo_message_add_timetag | ( | lo_message | m,
|  | lo_timetag | a )

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_true()

int lo_message_add_true | ( | lo_message | m | ) |

Append a data item and typechar of the specified type to a message. See lo_message_add_int32() for details.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_add_varargs()

int lo_message_add_varargs | ( | lo_message | m,
|  | const char * | types,
|  | va_list | ap )

Append a varargs list to a message.

The data will be added in OSC byteorder (bigendian). IMPORTANT: args list must be terminated with LO_ARGS_END, or this call will fail. This is used to do simple error checking on the sizes of parameters passed.

Parameters

  m | The message to be extended.
  types | The types of the data items in the message, types are defined in lo_types_common.h
  ap | The va_list created by a C function declared with an ellipsis (...) argument, and pre-initialised with "va_start(ap)". The types of the arguments passed here must agree with the types specified in the type parameter.

Returns
  Less than 0 on failure, 0 on success.

## ◆ lo_message_clear()

void lo_message_clear | ( | lo_message | m | ) |

Clear elements from a lo_message but do not free allocated memory.

## ◆ lo_message_clone()

lo_message lo_message_clone | ( | lo_message | m | ) |

Create a new lo_message object by cloning an already existing one.

## ◆ lo_message_decref()

int lo_message_decref | ( | lo_message | m | ) |

Subtract one from a message's reference count.

Messages are reference counted. In general decrementing the counter should be handled automatically using lo_message_free or lo_bundle_free_recursive, however if necessary the counter can be decremented manually.

## ◆ lo_message_deserialise()

lo_message lo_message_deserialise | ( | void * | data,
|  | size_t | size,
|  | int * | result )

Deserialise a raw OSC message and return a new lo_message object. Opposite of lo_message_serialise().

Parameters

  data | Pointer to the raw OSC message data in network transmission form (network byte order where appropriate).
  size | The size of data in bytes
  result | If this pointer is non-NULL, the result or error code will be written here.

Returns a new lo_message, or NULL if deserialisation fails. Use lo_message_free() to free the resulting object.

## ◆ lo_message_free()

void lo_message_free | ( | lo_message | m | ) |

Free memory allocated by lo_message_new() and any subsequent lo_message_add_int32 lo_message_add*() calls.

## ◆ lo_message_get_argc()

int lo_message_get_argc | ( | lo_message | m | ) |

Return the message argument count.

The result is valid until further data is added with lo_message_add*().

## ◆ lo_message_get_argv()

lo_arg ** lo_message_get_argv | ( | lo_message | m | ) |

Return the message arguments. Do not free the returned data.

The result is valid until further data is added with lo_message_add*().

## ◆ lo_message_get_source()

lo_address lo_message_get_source | ( | lo_message | m | ) |

Returns the source (lo_address) of an incoming message.

Returns NULL if the message is outgoing. Do not free the returned address. This is usually called on the lo_message passed to lo_method_handler, to set up bidirectional communication. See example_tcp_echo_server.c for an example of this.

## ◆ lo_message_get_timestamp()

lo_timetag lo_message_get_timestamp | ( | lo_message | m | ) |

Returns the timestamp (lo_timetag *) of a bundled incoming message.

Returns LO_TT_IMMEDIATE if the message is outgoing, or did not arrive contained in a bundle. Do not free the returned timetag.

## ◆ lo_message_get_types()

char * lo_message_get_types | ( | lo_message | m | ) |

Return the message type tag string.

The result is valid until further data is added with lo_message_add*().

## ◆ lo_message_incref()

void lo_message_incref | ( | lo_message | m | ) |

Add one to a message's reference count.

Messages are reference counted. If a message is multiply referenced, the message's counter should be incremented. It is automatically decremented by lo_message_free or lo_bundle_free_recursive, with lo_bundle_free_recursive being the preferable method if bundles are used.

## ◆ lo_message_length()

size_t lo_message_length | ( | lo_message | m,
|  | const char * | path )

Return the length of a message in bytes.

Parameters

  m | The message to be sized
  path | The path the message will be sent to

## ◆ lo_message_new()

lo_message lo_message_new | ( | void |  | ) |

Create a new lo_message object.

## ◆ lo_message_serialise()

void * lo_message_serialise | ( | lo_message | m,
|  | const char * | path,
|  | void * | to,
|  | size_t * | size )

Serialise the lo_message object to an area of memory and return a pointer to the serialised form. Opposite of lo_message_deserialise().

Parameters

  m | The message to be serialised
  path | The path the message will be sent to
  to | The address to serialise to, memory will be allocated if to is NULL.
  size | If this pointer is non-NULL the size of the memory area will be written here

The returned form is suitable to be sent over a low level OSC transport, having the correct endianess and bit-packed structure.

## ◆ lo_pattern_match()

int lo_pattern_match | ( | const char * | str,
|  | const char * | p )

Test a string against an OSC pattern glob.

Parameters

  str | The string to test
  p | The pattern to test against

Returns
  1 if true, 0 otherwise.

## ◆ lo_send_bundle()

int lo_send_bundle | ( | lo_address | targ,
|  | lo_bundle | b )

Send a lo_bundle object to address targ.

Bundles are constructed with the lo_bundle_new() and lo_bundle_add_message() functions.

## ◆ lo_send_bundle_from()

int lo_send_bundle_from | ( | lo_address | targ,
|  | lo_server | serv,
|  | lo_bundle | b )

Send a lo_bundle object to address targ from address of serv.

Bundles are constructed with the lo_bundle_new() and lo_bundle_add_message() functions.

Parameters

  targ | The address to send the bundle to
  serv | The server socket to send the bundle from (can be NULL to use new socket)
  b | The bundle itself

## ◆ lo_send_message()

int lo_send_message | ( | lo_address | targ,
|  | const char * | path,
|  | lo_message | msg )

Send a lo_message object to target targ.

This is slightly more efficient than lo_send() if you want to send a lot of similar messages. The messages are constructed with the lo_message_new() and lo_message_add*() functions.

## ◆ lo_send_message_from()

int lo_send_message_from | ( | lo_address | targ,
|  | lo_server | serv,
|  | const char * | path,
|  | lo_message | msg )

Send a lo_message object to target targ from address of serv.

This is slightly more efficient than lo_send() if you want to send a lot of similar messages. The messages are constructed with the lo_message_new() and lo_message_add*() functions.

Parameters

  targ | The address to send the message to
  serv | The server socket to send the message from (can be NULL to use new socket)
  path | The path to send the message to
  msg | The bundle itself

## ◆ lo_server_add_bundle_handlers()

int lo_server_add_bundle_handlers | ( | lo_server | s,
|  | lo_bundle_start_handler | sh,
|  | lo_bundle_end_handler | eh,
|  | void * | user_data )

Add bundle notification handlers to the specified server.

Parameters

  s | The server the method is to be added to.
  sh | The callback function that will be called before the messages of a bundle are dispatched
  eh | The callback function that will be called after the messages of a bundle are dispatched
  user_data | A value that will be passed to the user_data parameter of both callback functions.

## ◆ lo_server_add_method()

lo_method lo_server_add_method | ( | lo_server | s,
|  | const char * | path,
|  | const char * | typespec,
|  | lo_method_handler | h,
|  | const void * | user_data )

Add an OSC method to the specifed server.

Parameters

  s | The server the method is to be added to.
  path | The OSC path to register the method to. If NULL is passed the method will match all paths.
  typespec | The typespec the method accepts. Incoming messages with similar typespecs (e.g. ones with numerical types in the same position) will be coerced to the typespec given here.
  h | The method handler callback function that will be called if a matching message is received
  user_data | A value that will be passed to the callback function, h, when its invoked matching from this method.

Returns
  A unique pointer identifying the method. It should not be freed.

## ◆ lo_server_del_lo_method()

int lo_server_del_lo_method | ( | lo_server | s,
|  | lo_method | m )

Delete a specific OSC method from the specified server.

Parameters

  s | The server the method is to be removed from.
  m | The lo_method identifier returned from lo_server_add_method for the method to delete from the server.

Returns
  Non-zero if it was not found in the list of methods for the server.

## ◆ lo_server_del_method()

void lo_server_del_method | ( | lo_server | s,
|  | const char * | path,
|  | const char * | typespec )

Delete an OSC method from the specified server.

Parameters

  s | The server the method is to be removed from.
  path | The OSC path of the method to delete. If NULL is passed the method will match the generic handler.
  typespec | The typespec the method accepts.

## ◆ lo_server_dispatch_data()

int lo_server_dispatch_data | ( | lo_server | s,
|  | void * | data,
|  | size_t | size )

Dispatch a raw block of memory containing an OSC message.

This is useful when a raw block of memory is available that is structured as OSC, and you wish to use liblo to dispatch the message to a handler function as if it had been received over the network.

Parameters

  s | The lo_server to use for dispatching.
  data | Pointer to the raw OSC message data in network transmission form (network byte order where appropriate).
  size | The size of data in bytes

Returns the number of bytes used if successful, or less than 0 otherwise.

## ◆ lo_server_enable_coercion()

int lo_server_enable_coercion | ( | lo_server | server,
|  | int | enable )

Enables or disables type coercion during message dispatch.

Parameters

  server | The server to toggle this option for.
  enable | Non-zero to enable, or zero to disable type coercion.

Returns
  The previous value of this option.

## ◆ lo_server_enable_queue()

int lo_server_enable_queue | ( | lo_server | s,
|  | int | queue_enabled,
|  | int | dispatch_remaining )

Toggle event queue. If queueing is enabled, timetagged messages that are sent in advance of the current time will be put on an internal queue, and they will be dispatched at the indicated time. By default, queueing is enabled. Use this function to disable it, if it is desired to have a server process messages immediately. In that case, use lo_message_get_timestamp() to get the message timestamp from within a method handler.

Parameters

  s | A liblo server
  queue_enabled | Zero to disable queue, non-zero to enable.
  dispatch_remaining | If non-zero, previously queued messages will be immediately dispatched when queue is disabled.

Returns
  The previous state of queue behaviour. Zero if queueing was previously disabled, non-zero otherwise.

## ◆ lo_server_events_pending()

int lo_server_events_pending | ( | lo_server | s | ) |

Return true if there are scheduled events (eg. from bundles) waiting to be dispatched by the server.

## ◆ lo_server_free()

void lo_server_free | ( | lo_server | s | ) |

Free up memory used by the lo_server object.

Referenced by lo::Server::~Server().

## ◆ lo_server_get_port()

int lo_server_get_port | ( | lo_server | s | ) |

Return the port number that the server has bound to.

Useful when NULL is passed for the port number and you wish to know how to address the server.

## ◆ lo_server_get_protocol()

int lo_server_get_protocol | ( | lo_server | s | ) |

Return the protocol that the server is using.

Returned value will be one of LO_UDP, LO_TCP or LO_UNIX.

## ◆ lo_server_get_socket_fd()

int lo_server_get_socket_fd | ( | lo_server | s | ) |

Return the file descriptor of the server socket.

If the server protocol supports exposing the server's underlying receive mechanism for monitoring with select() or poll(), this function returns the file descriptor needed, otherwise, it returns -1.

WARNING: when using this function beware that not all OSC packets that are received are dispatched immediately. lo_server_events_pending() and lo_server_next_event_delay() can be used to tell if there are pending events and how long before you should attempt to receive them.

## ◆ lo_server_get_url()

char * lo_server_get_url | ( | lo_server | s | ) |

Return an OSC URL that can be used to contact the server.

The return value should be free()'d when it is no longer needed.

## ◆ lo_server_max_msg_size()

int lo_server_max_msg_size | ( | lo_server | s,
|  | int | req_size )

Set the maximum message size accepted by a server.

For UDP servers, the maximum message size cannot exceed 64k, due to the UDP transport specifications. For TCP servers, this number may be larger, but be aware that one or more contiguous blocks of memory of this size may be allocated by liblo. (At least one per connection.)

Parameters

  s | The server on which to operate.
  req_size | The new maximum message size to request, 0 if it should not be modified, or -1 if it should be set to unlimited. Note that an unlimited message buffer may make your application open to a denial of service attack.

Returns
  The new maximum message size is returned, which may or may not be equal to req_size. If -1 is returned, maximum size is unlimited.

## ◆ lo_server_new()

lo_server lo_server_new | ( | const char * | port,
|  | lo_err_handler | err_h )

Create a new server instance.

Using lo_server_recv(), lo_servers block until they receive OSC messages. Most likely you want non-blocking behaviour, so use of lo_server_recv_noblock() is encouraged or the lo_server_thread_new and "lo_server_thread_*" functions.

Parameters

  port | If NULL is passed then an unused UDP port will be chosen by the system, its number may be retrieved with lo_server_thread_get_port() so it can be passed to clients. Otherwise a decimal port number, service name or UNIX domain socket path may be passed.
  err_h | An error callback function that will be called if there is an error in messge reception or server creation. Pass NULL if you do not want error handling.

Referenced by lo::Server::Server(), and lo::Server::Server().

## ◆ lo_server_new_from_config()

lo_server lo_server_new_from_config | ( | lo_server_config * | config | ) |

Create a new server instance, using a configuration struct.

Parameters

  config | A pre-initialized config struct. A pointer to it will not be kept.

Returns
  A new lo_server instance.

## ◆ lo_server_new_from_url()

lo_server lo_server_new_from_url | ( | const char * | url,
|  | lo_err_handler | err_h )

Create a new server instance, taking port and the optional multicast group IP from an URL string.

Parameters

  url | The URL to specify the server parameters.
  err_h | An error callback function that will be called if there is an error in messge reception or server creation. Pass NULL if you do not want error handling.

Returns
  A new lo_server instance.

## ◆ lo_server_new_multicast()

lo_server lo_server_new_multicast | ( | const char * | group,
|  | const char * | port,
|  | lo_err_handler | err_h )

Create a new server instance, and join a UDP multicast group.

Parameters

  group | The multicast group to join. See documentation on IP multicast for the acceptable address range; e.g., http://tldp.org/HOWTO/Multicast-HOWTO-2.html
  port | If using UDP then NULL may be passed to find an unused port. Otherwise a decimal port number or service name or may be passed. If using UNIX domain sockets then a socket path should be passed here.
  err_h | An error callback function that will be called if there is an error in messge reception or server creation. Pass NULL if you do not want error handling.

Referenced by lo::Server::Server().

## ◆ lo_server_new_multicast_iface()

lo_server lo_server_new_multicast_iface | ( | const char * | group,
|  | const char * | port,
|  | const char * | iface,
|  | const char * | ip,
|  | lo_err_handler | err_h )

Create a new server instance, and join a UDP multicast group, optionally specifying which network interface to use. Note that usually only one of iface or ip are specified.

Parameters

  group | The multicast group to join. See documentation on IP multicast for the acceptable address range; e.g., http://tldp.org/HOWTO/Multicast-HOWTO-2.html
  port | If using UDP then NULL may be passed to find an unused port. Otherwise a decimal port number or service name or may be passed. If using UNIX domain sockets then a socket path should be passed here.
  iface | A string specifying the name of a network interface to use, or zero if not specified.
  ip | A string specifying the IP address of a network interface to use, or zero if not specified.
  err_h | An error callback function that will be called if there is an error in messge reception or server creation. Pass NULL if you do not want error handling.

Referenced by lo::Server::Server(), and lo::Server::Server().

## ◆ lo_server_new_with_proto()

lo_server lo_server_new_with_proto | ( | const char * | port,
|  | int | proto,
|  | lo_err_handler | err_h )

Create a new server instance, specifying protocol.

Using lo_server_recv(), lo_servers block until they receive OSC messages. Most likely you want non-blocking behaviour, so use of lo_server_recv_noblock() is encouraged or the lo_server_thread_new and "lo_server_thread_*" functions.

Parameters

  port | If using UDP then NULL may be passed to find an unused port. Otherwise a decimal port number orservice name or may be passed. If using UNIX domain sockets then a socket path should be passed here.
  proto | The protocol to use, should be one of LO_UDP, LO_TCP or LO_UNIX.
  err_h | An error callback function that will be called if there is an error in messge reception or server creation. Pass NULL if you do not want error handling.

Referenced by lo::Server::Server(), and lo::Server::Server().

## ◆ lo_server_next_event_delay()

double lo_server_next_event_delay | ( | lo_server | s | ) |

Return the time in seconds until the next scheduled event.

If the delay is greater than 100 seconds then it will return 100.0.

## ◆ lo_server_recv()

int lo_server_recv | ( | lo_server | s | ) |

Block, waiting for an OSC message to be received.

The blocking behavior of this function is, in most cases, undesireable, since a program with no incoming messages may never exit. It is encouraged to use lo_server_recv_noblock() instead, which is equivalent to lo_server_wait() and then lo_server_recv().

The return value is the number of bytes in the received message. The message will be dispatched to a matching method if one is found. In cases where no message is received but returning is necessary anyway, this function may return 0.

## ◆ lo_server_recv_noblock()

int lo_server_recv_noblock | ( | lo_server | s,
|  | int | timeout )

Look for an OSC message waiting to be received.

In new programs, this function should be prefered over lo_server_recv().

Parameters

  s | The server to wait for connections on.
  timeout | A timeout in milliseconds to wait for the incoming packet. a value of 0 will return immediately.

The return value is the number of bytes in the received message or 0 if there is no message. The message will be dispatched to a matching method if one is found.

## ◆ lo_server_wait()

int lo_server_wait | ( | lo_server | s,
|  | int | timeout )

Wait for an OSC message to be received.

Parameters

  s | The server to wait for connections on.
  timeout | A timeout in milliseconds to wait for the incoming packet. a value of 0 will return immediately.

The return value is 1 if there is a message waiting, 0 if there is no message, and -1 if there is an error that causes the function to return early. If there is a message waiting you can now call lo_server_recv() to receive that message. This is preferable to using lo_server_recv() alone, since otherwise it may never exit if no new messages are incoming.

## ◆ lo_servers_recv_noblock()

int lo_servers_recv_noblock | ( | lo_server * | s,
|  | int * | recvd,
|  | int | num_servers,
|  | int | timeout )

Look for an OSC message waiting to be received on multiple servers.

Parameters

  s | As array of servers to wait for connections on.
  recvd | An array to store the number of bytes received by each server in array s.
  num_servers | The number of servers in the array s.
  timeout | A timeout in milliseconds to wait for the incoming packet. a value of 0 will return immediately.

The return value is the total number of bytes received by all servers. The messages will be dispatched to a matching method if one is found.

## ◆ lo_servers_wait()

int lo_servers_wait | ( | lo_server * | s,
|  | int * | status,
|  | int | num_servers,
|  | int | timeout )

Wait on multiple servers for an OSC message to be received.

Parameters

  s | An array of servers to wait for connections on.
  status | An array to receive the status of each server.
  num_servers | The number of servers in the array s.
  timeout | A timeout in milliseconds to wait for the incoming packet. a value of 0 will return immediately.

The return value is the number of servers with a message waiting or -1 if there is an error that causes the function to return early. If there is a message waiting you can now call lo_server_recv() to receive that message. This is preferable to using lo_server_recv() alone, since otherwise it may never exit if no new messages are incoming.

## ◆ lo_string_contains_pattern()

int lo_string_contains_pattern | ( | const char * | str | ) |

Test if a string contains any OSC pattern characters.

Parameters

  str | The string to test

Returns
  1 if true, 0 otherwise.

## ◆ lo_strsize()

int lo_strsize | ( | const char * | s | ) |

A function to calculate the amount of OSC message space required by a C char *.

Returns the storage size in bytes, which will always be a multiple of four.

## ◆ lo_timetag_diff()

double lo_timetag_diff | ( | lo_timetag | a,
|  | lo_timetag | b )

Find the time difference between two timetags.

Returns a - b in seconds.

## ◆ lo_timetag_now()

void lo_timetag_now | ( | lo_timetag * | t | ) |

Return a timetag for the current time.

On exit the timetag pointed to by t is filled with the OSC representation of this instant in time.

Referenced by lo::now().

## ◆ lo_url_get_hostname()

char * lo_url_get_hostname | ( | const char * | url | ) |

Return the hostname portion of an OSC URL.

The return value should be free()'d when it is no longer needed.

## ◆ lo_url_get_path()

char * lo_url_get_path | ( | const char * | url | ) |

Return the path portion of an OSC URL.

The return value should be free()'d when it is no longer needed.

## ◆ lo_url_get_port()

char * lo_url_get_port | ( | const char * | url | ) |

Return the port portion of an OSC URL.

The return value should be free()'d when it is no longer needed.

## ◆ lo_url_get_protocol()

char * lo_url_get_protocol | ( | const char * | url | ) |

Return the protocol portion of an OSC URL, eg. udp, tcp.

This library uses OSC URLs of the form: osc.prot://hostname:port/path if the prot part is missing, UDP is assumed.

The return value should be free()'d when it is no longer needed.

## ◆ lo_url_get_protocol_id()

int lo_url_get_protocol_id | ( | const char * | url | ) |

Return the protocol ID of an OSC URL.

This library uses OSC URLs of the form: osc.prot://hostname:port/path if the prot part is missing, UDP is assumed. Returned value will be one of LO_UDP, LO_TCP, LO_UNIX or -1.

Returns
  An integer specifying the protocol. Return -1 when the protocol is not supported by liblo.